80f1456e8de35fa98e38f71a71a7f7132756d370
[deliverable/binutils-gdb.git] / configure.in
1 #! /bin/bash
2 ##############################################################################
3
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
8
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
13
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17 # Copyright (C) 1992, 93, 94, 95, 1996 Free Software Foundation, Inc.
18 #
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
23 #
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
28 #
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
32
33 ##############################################################################
34
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
40
41
42 # these libraries are used by various programs built for the host environment
43 #
44 host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
45
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
48 fi
49
50 # these tools are built for the host environment
51 #
52 host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch
53 prms send-pr gprof gdbtest tgas etc expect dejagnu sim bash
54 m4 autoconf ispell grep diff rcs cvs fileutils shellutils time
55 textutils wdiff find emacs emacs19 uudecode hello tar gzip indent
56 recode release sed utils guile perl apache inet gawk"
57
58
59 # these libraries are built for the target environment, and are built after
60 # the host libraries and the host tools (which may be a cross compiler)
61 #
62 target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
63
64
65 # these tools are built using the target libs, and are intended to run only
66 # in the target environment
67 #
68 # note: any program that *uses* libraries that are in the "target_libs"
69 # list belongs in this list. those programs are also very likely
70 # candidates for the "native_only" list which follows
71 #
72 target_tools="target-examples target-groff"
73
74 ################################################################################
75
76 ## These two lists are of directories that are to be removed from the
77 ## ${configdirs} list for either cross-compilations or for native-
78 ## compilations. For example, it doesn't make that much sense to
79 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
80 ## a native environment.
81
82 # directories to be built in the native environment only
83 #
84 native_only="autoconf cvs emacs emacs19 fileutils find gawk grep gzip hello
85 indent ispell m4 rcs recode sed shellutils tar textutils gash
86 uudecode wdiff gprof target-groff guile perl apache inet time
87 bash prms"
88
89 # directories to be built in a cross environment only
90 #
91 cross_only="target-libiberty target-libgloss target-newlib"
92
93 ## All tools belong in one of the four categories, and are assigned above
94 ## We assign ${configdirs} this way to remove all embedded newlines. This
95 ## is important because configure will choke if they ever get through.
96 ## ${configdirs} is directories we build using the host tools.
97 ## ${target_configdirs} is directories we build using the target tools.
98 #
99 configdirs=`echo ${host_libs} ${host_tools}`
100 target_configdirs=`echo ${target_libs} ${target_tools}`
101
102 ################################################################################
103
104 srctrigger=move-if-change
105 srcname="gnu development package"
106
107 # This gets set non-empty for some net releases of packages.
108 appdirs=""
109
110 # per-host:
111
112 # Work in distributions that contain no compiler tools, like Autoconf.
113 if [ -d ${srcdir}/config ]; then
114 case "${host}" in
115 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
116 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
117 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
118 m68k-*-linux*) host_makefile_frag=config/mh-linux ;;
119 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
120 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
121 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
122 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
123 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
124 mips*-sgi-irix6*) host_makefile_frag=config/mh-irix6 ;;
125 mips*-sgi-irix5*) host_makefile_frag=config/mh-irix5 ;;
126 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
127 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
128 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
129 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
130 i[345]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
131 i[345]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
132 i[345]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
133 i[345]86-*-sco*) host_makefile_frag=config/mh-sco ;;
134 i[345]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
135 i[345]86-*-linux*) host_makefile_frag=config/mh-linux ;;
136 i[345]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
137 i[345]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
138 i[345]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
139 *-cygwin32*) host_makefile_frag=config/mh-cygwin32 ;;
140 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
141 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
142 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
143 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
144 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
145 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
146 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
147 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
148 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
149 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
150 esac
151 fi
152
153 # If we aren't going to be using gcc, see if we can extract a definition
154 # of CC from the fragment.
155 if [ -z "${CC}" -a "${build}" = "${host}" ]; then
156 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
157 found=
158 for dir in $PATH; do
159 test -z "$dir" && dir=.
160 if test -f $dir/gcc; then
161 found=yes
162 break
163 fi
164 done
165 IFS="$save_ifs"
166 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
167 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
168 if [ -n "${xx}" ] ; then
169 CC=$xx
170 fi
171 fi
172 fi
173
174 # We default to --with-shared on platforms where -fpic is meaningless.
175 # Well, we don't yet, but we will.
176 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
177 case "${target}" in
178 alpha-dec-osf*) enable_shared=yes ;;
179 alpha-*-linux*) enable_shared=yes ;;
180 mips-sgi-irix5*) enable_shared=yes ;;
181 *) enable_shared=no ;;
182 esac
183 fi
184
185 case "${enable_shared}" in
186 yes) shared=yes ;;
187 no) shared=no ;;
188 "") shared=no ;;
189 *) shared=yes ;;
190 esac
191
192 if [ x${shared} = xyes ]; then
193 waugh=
194 case "${host}" in
195 hppa*) waugh=config/mh-papic ;;
196 i[345]86-*) waugh=config/mh-x86pic ;;
197 sparc64-*) waugh=config/mh-sparcpic ;;
198 *) waugh=config/mh-${host_cpu}pic ;;
199 esac
200 if [ -f ${srcdir}/${waugh} ]; then
201 if [ -n "${host_makefile_frag}" ] ; then
202 cat ${srcdir}/${host_makefile_frag} > mh-frag
203 cat ${srcdir}/${waugh} >> mh-frag
204 host_makefile_frag=mh-frag
205 else
206 host_makefile_frag=${waugh}
207 fi
208 fi
209 fi
210
211 # per-target:
212
213 case "${target}" in
214 v810*) target_makefile_frag=config/mt-v810 ;;
215 i[345]86-*-netware*) target_makefile_frag=config/mt-netware ;;
216 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
217 esac
218
219 skipdirs=
220 gasdir=gas
221 use_gnu_ld=
222 use_gnu_as=
223
224 # some tools are so dependent upon X11 that if we're not building with X,
225 # it's not even worth trying to configure, much less build, that tool.
226
227 case ${with_x} in
228 yes | "") # the default value for this tree is that X11 is available
229 ;;
230 no)
231 skipdirs="${skipdirs} tk gash"
232 ;;
233 *)
234 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
235 ;;
236 esac
237
238 # Some tools are only suitable for building in a "native" situation.
239 # Those are added when we have a host==target configuration. For cross
240 # toolchains, we add some directories that should only be useful in a
241 # cross-compiler.
242
243 is_cross_compiler=
244
245 if [ x"${host}" = x"${target}" ] ; then
246 # when doing a native toolchain, don't build the targets
247 # that are in the 'cross only' list
248 skipdirs="${skipdirs} ${cross_only}"
249 is_cross_compiler=no
250 target_subdir=.
251 else
252 # similarly, don't build the targets in the 'native only'
253 # list when building a cross compiler
254 skipdirs="${skipdirs} ${native_only}"
255 is_cross_compiler=yes
256 target_subdir=${target_alias}
257 if [ ! -d ${target_subdir} ] ; then
258 if mkdir ${target_subdir} ; then true
259 else
260 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
261 exit 1
262 fi
263 fi
264 fi
265
266 copy_dirs=
267
268 # Handle --with-headers=XXX. The contents of the named directory are
269 # copied to $(tooldir)/sys-include.
270 if [ x"${with_headers}" != x ]; then
271 if [ x${is_cross_compiler} = xno ]; then
272 echo 1>&2 '***' --with-headers is only supported when cross compiling
273 exit 1
274 fi
275 case "${exec_prefixoption}" in
276 "") x=${prefix} ;;
277 *) x=${exec_prefix} ;;
278 esac
279 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
280 fi
281
282 # Handle --with-libs=XXX. Multiple directories are permitted. The
283 # contents are copied to $(tooldir)/lib.
284 if [ x"${with_libs}" != x ]; then
285 if [ x${is_cross_compiler} = xno ]; then
286 echo 1>&2 '***' --with-libs is only supported when cross compiling
287 exit 1
288 fi
289 # Copy the libraries in reverse order, so that files in the first named
290 # library override files in subsequent libraries.
291 case "${exec_prefixoption}" in
292 "") x=${prefix} ;;
293 *) x=${exec_prefix} ;;
294 esac
295 for l in ${with_libs}; do
296 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
297 done
298 fi
299
300 # If both --with-headers and --with-libs are specified, default to
301 # --without-newlib.
302 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
303 if [ x"${with_newlib}" = x ]; then
304 with_newlib=no
305 fi
306 fi
307
308 # Recognize --with-newlib/--without-newlib.
309 if [ x${with_newlib} = xno ]; then
310 skipdirs="${skipdirs} target-newlib"
311 elif [ x${with_newlib} = xyes ]; then
312 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
313 fi
314
315 # Default to using --with-stabs for certain targets.
316 if [ x${with_stabs} = x ]; then
317 case "${target}" in
318 mips*-*-* | alpha*-*-osf* | i[345]86*-*-sysv4* | i[345]86*-*-unixware*)
319 with_stabs=yes;
320 withoptions="${withoptions} --with-stabs"
321 ;;
322 esac
323 fi
324
325 # Handle ${copy_dirs}
326 set fnord ${copy_dirs}
327 shift
328 while [ $# != 0 ]; do
329 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
330 :
331 else
332 echo Copying $1 to $2
333
334 # Use the install script to create the directory and all required
335 # parent directories.
336 if [ -d $2 ]; then
337 :
338 else
339 echo >config.temp
340 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
341 fi
342
343 # Copy the directory, assuming we have tar.
344 # FIXME: Should we use B in the second tar? Not all systems support it.
345 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
346
347 # It is the responsibility of the user to correctly adjust all
348 # symlinks. If somebody can figure out how to handle them correctly
349 # here, feel free to add the code.
350
351 echo $1 > $2/COPIED
352 fi
353 shift; shift
354 done
355
356 # Configure extra directories which are host specific
357
358 case "${host}" in
359 i[345]86-*-go32*)
360 configdirs="$configdirs dosrel" ;;
361 *-cygwin32*)
362 configdirs="$configdirs dosrel" ;;
363 esac
364
365 # Remove more programs from consideration, based on the host or
366 # target this usually means that a port of the program doesn't
367 # exist yet.
368
369 noconfigdirs=""
370
371 case "${host}" in
372 i[345]86-*-vsta)
373 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
374 ;;
375 i[345]86-*-go32)
376 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
377 ;;
378 *-*-cygwin32)
379 noconfigdirs="tk tcl expect dejagnu cvs autoconf bison send-pr gprof rcs guile perl texinfo apache inet"
380 ;;
381 ppc*-*-pe)
382 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
383 ;;
384 esac
385
386
387 case "${target}" in
388 *-*-netware)
389 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
390 ;;
391 *-*-vxworks*)
392 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
393 ;;
394 alpha-dec-osf*)
395 # ld works, but does not support shared libraries. emacs doesn't
396 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
397 # gas doesn't generate exception information.
398 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib target-libgloss"
399 ;;
400 alpha*-*-*vms*)
401 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
402 ;;
403 alpha*-*-*)
404 # newlib is not 64 bit ready
405 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
406 ;;
407 # start-sanitize-arc
408 arc-*-*)
409 noconfigdirs="$noconfigdirs target-libgloss"
410 ;;
411 # end-sanitize-arc
412 arm-*-pe*)
413 noconfigdirs="$noconfigdirs target-libgloss"
414 ;;
415 arm-*-riscix*)
416 noconfigdirs="$noconfigdirs ld target-libgloss"
417 ;;
418 # start-sanitize-d10v
419 d10v-*-*)
420 noconfigdirs="$noconfigdirs gdb target-libgloss"
421 ;;
422 # end-sanitize-d10v
423 h8300*-*-* | \
424 h8500-*-*)
425 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
426 ;;
427 hppa*-*-*elf* | \
428 hppa*-*-lites*)
429 # Do configure ld/binutils/gas for this case.
430 ;;
431 hppa*-*-*)
432 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
433 # cc is gcc, and on any system a user should be able to link cc to
434 # whatever they want. FIXME, emacs emacs19).
435 case "${CC}" in
436 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
437 *) ;;
438 esac
439 noconfigdirs="$noconfigdirs ld shellutils"
440 ;;
441 i[345]86-*-go32)
442 # but don't build gdb
443 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
444 ;;
445 *-*-cygwin32)
446 target_configdirs="$target_configdirs target-winsup"
447 noconfigdirs="$noconfigdirs tcl tk expect target-libgloss"
448 # always build newlib.
449 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
450
451 # Can't build gdb for cygwin32 if not native.
452 case "${host}" in
453 *-*-cygwin32) ;; # keep gdb
454 *) noconfigdirs="$noconfigdirs gdb"
455 esac
456 ;;
457 i[345]86-*-pe)
458 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
459 ;;
460 i[345]86-*-sco3.2v5*)
461 # The linker does not yet know about weak symbols in COFF,
462 # and is not configured to handle mixed ELF and COFF.
463 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
464 ;;
465 i[345]86-*-sco*)
466 noconfigdirs="$noconfigdirs gprof target-libgloss"
467 ;;
468 i[345]86-*-solaris2*)
469 # The linker does static linking correctly, but the Solaris C library
470 # has bugs such that some important functions won't work when statically
471 # linked. (See man pages for getpwuid, for example.)
472 noconfigdirs="$noconfigdirs ld target-libgloss"
473 ;;
474 i[345]86-*-sysv4*)
475 # The SYSV4 C compiler doesn't handle Emacs correctly
476 case "${CC}" in
477 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
478 *) ;;
479 esac
480 # but that's okay since emacs doesn't work anyway
481 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
482 ;;
483 powerpc-*-aix*)
484 # copied from rs6000-*-* entry
485 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
486 # This is needed until gcc and ld are fixed to work together.
487 use_gnu_ld=no
488 ;;
489 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
490 target_configdirs="$target_configdirs target-winsup"
491 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss"
492 # always build newlib.
493 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
494 ;;
495 # This is temporary until we can link against shared libraries
496 powerpcle-*-solaris*)
497 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect"
498 ;;
499 rs6000-*-lynxos*)
500 # The CVS server code doesn't work on the RS/6000
501 # Newlib makes problems for libg++ in crosses.
502 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
503 ;;
504 rs6000-*-aix*)
505 noconfigdirs="$noconfigdirs gprof"
506 # This is needed until gcc and ld are fixed to work together.
507 use_gnu_ld=no
508 ;;
509 rs6000-*-*)
510 noconfigdirs="$noconfigdirs gprof"
511 ;;
512 m68k-apollo-*)
513 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
514 ;;
515 mips*-*-irix5*)
516 # The GNU linker does not support shared libraries.
517 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
518 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
519 ;;
520 mips*-*-irix6*)
521 # The GNU linker does not support shared libraries.
522 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
523 # BFD does not have Irix 6 support yet.
524 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes gdb readline mmalloc sim gprof emacs target-libgloss"
525 ;;
526 mips*-dec-bsd*)
527 noconfigdirs="$noconfigdirs gprof target-libgloss"
528 ;;
529 mips*-*-bsd*)
530 noconfigdirs="$noconfigdirs gprof target-libgloss"
531 ;;
532 mips*-*-*)
533 noconfigdirs="$noconfigdirs gprof"
534 ;;
535 romp-*-*)
536 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
537 ;;
538 sh-*-*)
539 case "${host}" in
540 i[345]86-*-vsta) ;; # don't add gprof back in
541 i[345]86-*-go32) ;; # don't add gprof back in
542 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
543 esac
544 noconfigdirs="$noconfigdirs target-libgloss"
545 ;;
546 sparc-*-sunos4*)
547 if [ x${is_cross_compiler} != xno ] ; then
548 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
549 else
550 use_gnu_ld=no
551 fi
552 ;;
553 v810-*-*)
554 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
555 ;;
556 vax-*-vms)
557 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
558 ;;
559 vax-*-*)
560 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
561 ;;
562 *-*-lynxos*)
563 # Newlib makes problems for libg++ in crosses.
564 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
565 ;;
566 *-*-macos* | \
567 *-*-mpw*)
568 # Macs want a resource compiler.
569 configdirs="$configdirs grez"
570 ;;
571 esac
572
573 # targets that need a second pass
574 case "${target}" in
575 *-gm-magic*)
576 noconfigdirs="$noconfigdirs target-libgloss"
577 ;;
578 esac
579
580 # If we aren't building newlib, then don't build libgloss, since libgloss
581 # depends upon some newlib header files.
582 case "${noconfigdirs}" in
583 *target-libgloss*) ;;
584 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
585 esac
586
587 # If we are building a Canadian Cross, discard tools that can not be built
588 # using a cross compiler. FIXME: These tools should be fixed.
589 if [ "${build}" != "${host}" ]; then
590 noconfigdirs="$noconfigdirs tcl tk expect dejagnu"
591 fi
592
593 # Make sure we don't let GNU ld be added if we didn't want it.
594 if [ x$with_gnu_ld = xno ]; then
595 use_gnu_ld=no
596 noconfigdirs="$noconfigdirs ld"
597 fi
598
599 # Make sure we don't let GNU as be added if we didn't want it.
600 if [ x$with_gnu_as = xno ]; then
601 use_gnu_as=no
602 noconfigdirs="$noconfigdirs gas"
603 fi
604
605 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
606 # $target_configdirs.
607 # If we have the source for $noconfigdirs entries, add them to $notsupp.
608
609 notsupp=""
610 for dir in . $skipdirs $noconfigdirs ; do
611 dirname=`echo $dir | sed -e s/target-//g`
612 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
613 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
614 if [ -r $srcdir/$dirname/configure ] \
615 || [ -r $srcdir/$dirname/configure.in ]; then
616 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
617 true
618 else
619 notsupp="$notsupp $dir"
620 fi
621 fi
622 fi
623 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
624 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
625 if [ -r $srcdir/$dirname/configure ] \
626 || [ -r $srcdir/$dirname/configure.in ]; then
627 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
628 true
629 else
630 notsupp="$notsupp $dir"
631 fi
632 fi
633 fi
634 done
635
636 # Sometimes the tools are distributed with libiberty but with no other
637 # libraries. In that case, we don't want to build target-libiberty.
638 if [ -n "${target_configdirs}" ]; then
639 others=
640 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
641 if [ "$i" != "libiberty" ]; then
642 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
643 others=yes;
644 break;
645 fi
646 fi
647 done
648 if [ -z "${others}" ]; then
649 target_configdirs=
650 fi
651 fi
652
653 # Deconfigure all subdirectories, in case we are changing the
654 # configuration from one where a subdirectory is supported to one where it
655 # is not.
656 if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
657 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
658 rm -f $i/Makefile
659 done
660 fi
661 if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
662 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
663 rm -f ${target_subdir}/$i/Makefile
664 done
665 fi
666
667 # Produce a warning message for the subdirs we can't configure.
668 # This isn't especially interesting in the Cygnus tree, but in the individual
669 # FSF releases, it's important to let people know when their machine isn't
670 # supported by the one or two programs in a package.
671
672 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
673 # If $appdirs is non-empty, at least one of those directories must still
674 # be configured, or we error out. (E.g., if the gas release supports a
675 # specified target in some subdirs but not the gas subdir, we shouldn't
676 # pretend that all is well.)
677 if [ -n "$appdirs" ]; then
678 for dir in $appdirs ; do
679 if [ -r $dir/Makefile.in ]; then
680 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
681 appdirs=""
682 break
683 fi
684 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
685 appdirs=""
686 break
687 fi
688 fi
689 done
690 if [ -n "$appdirs" ]; then
691 echo "*** This configuration is not supported by this package." 1>&2
692 exit 1
693 fi
694 fi
695 # Okay, some application will build, or we don't care to check. Still
696 # notify of subdirs not getting built.
697 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
698 echo " ${notsupp}" 1>&2
699 echo " (Any other directories should still work fine.)" 1>&2
700 fi
701
702 # Set with_gnu_as and with_gnu_ld as appropriate.
703 #
704 # This is done by determining whether or not the appropriate directory
705 # is available, and by checking whether or not specific configurations
706 # have requested that this magic not happen.
707 #
708 # The command line options always override the explicit settings in
709 # configure.in, and the settings in configure.in override this magic.
710 #
711 # If the default for a toolchain is to use GNU as and ld, and you don't
712 # want to do that, then you should use the --without-gnu-as and
713 # --without-gnu-ld options for the configure script.
714
715 if [ x${use_gnu_as} = x ] ; then
716 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
717 with_gnu_as=yes
718 withoptions="$withoptions --with-gnu-as"
719 fi
720 fi
721
722 if [ x${use_gnu_ld} = x ] ; then
723 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
724 with_gnu_ld=yes
725 withoptions="$withoptions --with-gnu-ld"
726 fi
727 fi
728
729 if [ x${shared} = xyes ]; then
730 case "${target}" in
731 hppa*) target_makefile_frag=config/mt-papic ;;
732 i[345]86-*) target_makefile_frag=config/mt-x86pic ;;
733 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
734 esac
735 fi
736
737 # post-target:
738
739 # Make sure that the compiler is able to generate an executable. If it
740 # can't, we are probably in trouble. We don't care whether we can run the
741 # executable--we might be using a cross compiler--we only care whether it
742 # can be created. At this point the main configure script has set CC.
743 echo "int main () { return 0; }" > conftest.c
744 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
745 if [ $? = 0 ] && [ -s conftest ]; then
746 :
747 else
748 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
749 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
750 rm -f conftest*
751 exit 1
752 fi
753 rm -f conftest*
754
755 # The Solaris /usr/ucb/cc compiler does not appear to work.
756 case "${host}" in
757 sparc-sun-solaris2*)
758 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
759 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
760 could_use=
761 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
762 if [ -d /opt/cygnus/bin ] ; then
763 if [ "$could_use" = "" ] ; then
764 could_use="/opt/cygnus/bin"
765 else
766 could_use="$could_use or /opt/cygnus/bin"
767 fi
768 fi
769 if [ "$could_use" = "" ] ; then
770 echo "Warning: compilation may fail because you're using"
771 echo "/usr/ucb/cc. You should change your PATH or CC "
772 echo "variable and rerun configure."
773 else
774 echo "Warning: compilation may fail because you're using"
775 echo "/usr/ucb/cc, when you should use the C compiler from"
776 echo "$could_use. You should change your"
777 echo "PATH or CC variable and rerun configure."
778 fi
779 fi
780 ;;
781 esac
782
783 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
784 # binutils tools will find libbfd.so.
785 if [ "${shared}" = "yes" ]; then
786 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
787 Makefile > Makefile.tem
788 rm -f Makefile
789 mv -f Makefile.tem Makefile
790
791 case "${host}" in
792 *-*-hpux*)
793 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
794 Makefile > Makefile.tem
795 rm -f Makefile
796 mv -f Makefile.tem Makefile
797 ;;
798 esac
799 fi
800
801 # Record target_configdirs and the configure arguments in Makefile.
802 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
803 targargs=`echo "${arguments}" | \
804 sed -e 's/--norecursion//' \
805 -e 's/--cache[a-z-]*=[^ ]*//' \
806 -e 's/--ho[a-z-]*=[^ ]*//' \
807 -e 's/--ta[a-z-]*=[^ ]*//'`
808
809 # Passing a --with-cross-host argument lets the target libraries know
810 # whether they are being built with a cross-compiler or being built
811 # native. However, it would be better to use other mechanisms to make the
812 # sorts of decisions they want to make on this basis. Please consider
813 # this option to be deprecated. FIXME.
814 if [ x${is_cross_compiler} = xyes ]; then
815 targargs="--with-cross-host=${host_alias} ${targargs}"
816 fi
817
818 targargs="--host=${target_alias} ${targargs}"
819 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
820 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
821 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
822 Makefile > Makefile.tem
823 rm -f Makefile
824 mv -f Makefile.tem Makefile
825
826 #
827 # Local Variables:
828 # fill-column: 131
829 # End:
830 #
This page took 0.048855 seconds and 3 git commands to generate.